> ## Documentation Index
> Fetch the complete documentation index at: https://docs.incident.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update

> Update the credentials or configuration of a telemetry data source. Provide only the config block that matches your data source type (e.g. grafana_config for Grafana, datadog_config for Datadog). New credentials are validated against the provider before being saved.



## OpenAPI

````yaml /openapi/tags/telemetry-v2.json put /v2/telemetry/data_sources/{id}
openapi: 3.0.3
info:
  description: "This is the API reference for incident.io.\n\nIt documents available API endpoints, provides examples of how to use it, and\ninstructions around things like authentication and error handling.\n\nThe API is hosted at:\n\n- https://api.incident.io/\n\nAnd you will need to create an API key via your [incident.io\ndashboard](https://app.incident.io/settings/api-keys) to make requests.\n\n# Making requests\n\nHere are the key concepts required to make requests to the incident.io API.\n\n## Authentication\n\nFor all requests made to the incident.io API, you'll need an API key.\n\nTo create an API key, head to the incident dashboard and visit [API\nkeys](https://app.incident.io/settings/api-keys). When you create the key, you'll be able to choose what actions it\ncan take for your account: choose carefully, as those roles can only be set\nwhen you first create the key. We'll only show you the token once, so make sure\nyou store it somewhere safe.\n\nAPI keys are global to your incident.io account, and can be managed by anyone\nwho has the right permissions. We display the user that created the API key,\nand the API key will remain valid if that user becomes deactivated.\n\nOnce you have the key, you should make requests to the API that set the\n`Authorization` request header using a \"Bearer\" authentication scheme:\n\n```\nAuthorization: Bearer <YOUR_API_KEY>\n```\n\n## Rate Limits\n\nThe incident.io API enforces rate limits to ensure consistent performance for all users.\n\nThe default rate limit is 1200 requests/minute per API key. This limit applies to most endpoints across the API.\n\nSome endpoints have lower rate limits, particularly those that interact with external third-party systems that impose\ntheir own limitations. These specific limits vary by endpoint, and we recommend relying on the rate-limit error\nresponses to understand usage patterns and implement appropriate retry strategies.\n\nWhen you exceed a rate limit, the API will respond with a `429 Too Many Requests` status code, along with a JSON\nresponse that includes information about the limit and when you can retry:\n\n```json\n{\n    \"type\": \"too_many_requests\",\n    \"status\": 429,\n    \"request_id\": \"b839a403-7704-41c1-bf6a-39a2d68caefa\",\n    \"rate_limit\": {\n        \"name\": \"api_key_name\",\n        \"limit\": 1200,\n        \"remaining\": 0,\n        \"retry_after\": \"Thu, 17 Apr 2025 11:17:18 UTC\"\n    },\n    \"errors\": [\n        {\n            \"code\": \"too_many_requests\",\n            \"message\": \"Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.\"\n        }\n    ]\n}\n```\n\nThe response includes:\n* The name of the API key (`name`)\n* The bucket limit (`limit`)\n* The number of requests remaining (`remaining`)\n* When you can retry requests (`retry_after`)\n\n## Errors\n\nWe use standard HTTP response codes to indicate the status or failure of API\nrequests.\n\nThe API response body will be JSON, and contain more detailed information on the\nnature of the error.\n\nAn example error when a request is made without an API key:\n\n```json\n{\n  \"type\": \"authentication_error\",\n  \"status\": 401,\n  \"request_id\": \"8e3cc412-b49d-4957-9073-2c19d2c61804\",\n  \"errors\": [\n    {\n      \"code\": \"missing_authorization_material\",\n      \"message\": \"No authorization material provided in request\"\n    }\n  ]\n}\n```\n\nNote that the error:\n\n- Contains the HTTP status (`401`)\n- References the type of error (`authentication_error`)\n- Includes a `request_id` that can be provided to incident.io support to help\n\tdebug questions with your API request\n- Provides a list of individual errors, which go into detail about why the error\n\toccurred\n\nThe most common error will be a 422 Validation Error, which is returned when the\nrequest was rejected due to failing validations.\n\nThese errors look like this:\n\n```json\n{\n  \"type\": \"validation_error\",\n  \"status\": 422,\n  \"request_id\": \"631766c4-4afd-4803-997c-cd700928fa4b\",\n  \"errors\": [\n    {\n      \"code\": \"is_required\",\n      \"message\": \"A severity is required to open an incident\",\n      \"source\": {\n        \"field\": \"severity_id\"\n      }\n    }\n  ]\n}\n```\n\nThis error is caused by not providing a severity identifier, which should be at\nthe `severity_id` field of the request payload. Errors like these can be mapped to\nforms, should you be integrating with the API from a user-interface.\n\n## Compatibility\n\nWe won't make breaking changes to existing API services or endpoints, but will\nexpect integrators to upgrade themselves to the latest API endpoints within 3\nmonths of us deprecating the old service.\n\nWe will make changes that are considered backwards compatible, which include:\n\n- Adding new API endpoints and services\n- Adding new properties to responses from existing API endpoints\n- Reordering properties returned from existing API endpoints\n- Adding optional request parameters to existing API endpoints\n- Altering the format or length of IDs\n- Adding new values to enums\n\nIt is important that clients are robust to these changes, to ensure reliable\nintegrations.\n\nAs an example, if you are generating a client using an openapi-generator, ensure\nthe generated client is configured to support unknown enum values, often\nconfigured via the `enumUnknownDefaultCase` parameter.\n\nWhen breaking changes are unavoidable, we'll create a new service version on a\nseparate path, and run them in parallel.\n\nFor example:\n\n- https://api.incident.io/v1/incidents\n- https://api.incident.io/v2/incidents\n\nFor any questions, email support@incident.io.\n"
  title: incident.io
  version: 1.0.0
servers:
  - url: https://api.incident.io
security:
  - BearerAuth: []
tags:
  - description: Manage telemetry data source integrations.
    name: Telemetry V2
paths:
  /v2/telemetry/data_sources/{id}:
    put:
      tags:
        - Telemetry V2
      summary: Update
      description: >-
        Update the credentials or configuration of a telemetry data source.
        Provide only the config block that matches your data source type (e.g.
        grafana_config for Grafana, datadog_config for Datadog). New credentials
        are validated against the provider before being saved.
      operationId: Telemetry V2_UpdateDataSource
      parameters:
        - description: Data source ID
          example: 01G0J1EXE7AXZ2C93K61WBPYEH
          in: path
          name: id
          required: true
          schema:
            description: Data source ID
            example: 01G0J1EXE7AXZ2C93K61WBPYEH
            type: string
      requestBody:
        content:
          application/json:
            example:
              datadog_config:
                api_key: abc123
              grafana_config:
                api_key: glsa_123
              name: Production Grafana
            schema:
              $ref: '#/components/schemas/TelemetryUpdateDataSourcePayloadV2'
        required: true
      responses:
        '200':
          content:
            application/json:
              example:
                data_source:
                  created_at: '2021-08-17T13:28:57.801578Z'
                  enabled: true
                  id: 01G0J1EXE7AXZ2C93K61WBPYEH
                  name: Primary Prometheus
                  provider: grafana
                  source_type: grafana
                  updated_at: '2021-08-17T13:28:57.801578Z'
              schema:
                $ref: '#/components/schemas/TelemetryUpdateDataSourceResultV2'
          description: OK response.
components:
  schemas:
    TelemetryUpdateDataSourcePayloadV2:
      example:
        datadog_config:
          api_key: abc123
        grafana_config:
          api_key: glsa_123
        name: Production Grafana
      properties:
        datadog_config:
          $ref: '#/components/schemas/TelemetryDatadogUpdateConfigV2'
        grafana_config:
          $ref: '#/components/schemas/TelemetryGrafanaUpdateConfigV2'
        name:
          description: Updated display name
          example: Production Grafana
          type: string
      type: object
    TelemetryUpdateDataSourceResultV2:
      example:
        data_source:
          created_at: '2021-08-17T13:28:57.801578Z'
          enabled: true
          id: 01G0J1EXE7AXZ2C93K61WBPYEH
          name: Primary Prometheus
          provider: grafana
          source_type: grafana
          updated_at: '2021-08-17T13:28:57.801578Z'
      properties:
        data_source:
          $ref: '#/components/schemas/TelemetryDataSourceV2'
      required:
        - data_source
      type: object
    TelemetryDatadogUpdateConfigV2:
      description: Datadog-specific credential updates
      example:
        api_key: abc123
      properties:
        api_key:
          description: New Datadog API key
          example: abc123
          type: string
      type: object
    TelemetryGrafanaUpdateConfigV2:
      description: Grafana-specific credential updates
      example:
        api_key: glsa_123
      properties:
        api_key:
          description: New Grafana service account token
          example: glsa_123
          type: string
      type: object
    TelemetryDataSourceV2:
      description: A telemetry data source integration
      properties:
        created_at:
          description: When this data source was created
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
        enabled:
          description: Whether this data source is enabled
          example: true
          type: boolean
        id:
          description: Unique identifier for this data source
          example: 01G0J1EXE7AXZ2C93K61WBPYEH
          type: string
        name:
          description: Human-readable name of the data source
          example: Primary Prometheus
          type: string
        provider:
          description: Provider that hosts this data source
          example: grafana
          type: string
        source_type:
          description: Type of data source (e.g., prometheus, loki, tempo)
          example: grafana
          type: string
        updated_at:
          description: When this data source was last updated
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
      required:
        - id
        - name
        - provider
        - source_type
        - enabled
        - created_at
        - updated_at
      type: object
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: API key from your incident.io dashboard (Settings → API keys)

````